import { ref as z, useAttrs as Z, computed as M, resolveComponent as s, openBlock as l, createBlock as a, normalizeProps as ee, guardReactiveProps as te, unref as t, withCtx as r, createElementVNode as H, createVNode as w, toDisplayString as Y, createElementBlock as f, mergeProps as i, toHandlers as p, createSlots as le, renderSlot as I, createCommentVNode as c, Fragment as b, renderList as h, resolveDynamicComponent as $, createTextVNode as N } from "vue";
const ne = { key: 1 }, ae = {
  name: "k-field"
}, ue = /* @__PURE__ */ Object.assign(ae, {
  emits: ["input"],
  setup(oe, { emit: P }) {
    const V = P, S = z(), e = Z(), R = M(() => e.type ? ["text", "textarea"].includes(e.type) : !0), g = z(null);
    M(() => e.type === "number");
    const T = M(() => "year/month/date/dates/week/datetime/datetimerange/daterange/monthrange".split("/").includes(e.type)), E = M(() => ["datetime", "datetimerange"].includes(e.type) ? "YYYY-MM-DD HH:mm:ss" : "YYYY-MM-DD"), L = M(() => e.value ? ["datetime", "datetimerange"].includes(e.type) ? A(e.value) : j(e.value) : ""), F = (n) => {
      V("input", typeof n == "string" ? n.trim() : n);
    }, y = (n) => {
      V("input", typeof n == "string" ? n.trim() : n);
    }, Q = (n, u) => {
      let _ = S.value.getCheckedNodes();
      V("input", _);
    }, j = (n) => {
      if (!n) return "";
      let u = new Date(Number(n)), _ = u.getFullYear() + "-", m = (u.getMonth() + 1 < 10 ? "0" + (u.getMonth() + 1) : u.getMonth() + 1) + "-", k = v(u.getDate());
      return _ + m + k;
    }, v = (n) => n < 10 ? "0" + n : n, A = (n) => {
      if (!n) return "";
      let u = new Date(n), _ = u.getFullYear() + "-", m = (u.getMonth() + 1 < 10 ? "0" + (u.getMonth() + 1) : u.getMonth() + 1) + "-", k = v(u.getDate()) + " ", x = v(u.getHours()) + ":", C = v(u.getMinutes()) + ":", D = v(u.getSeconds());
      return _ + m + k + x + C + D;
    };
    return (n, u) => {
      const _ = s("QuestionFilled"), m = s("el-icon"), k = s("el-tooltip"), x = s("el-input"), C = s("el-option"), D = s("el-select"), O = s("el-tree-select"), q = s("el-input-number"), G = s("el-radio"), B = s("el-radio-group"), J = s("el-radio-button"), K = s("el-checkbox"), U = s("el-checkbox-group"), W = s("el-date-picker"), X = s("el-form-item");
      return l(), a(X, ee(te(t(e))), {
        label: r(() => [
          t(e).tip ? (l(), a(k, {
            key: 0,
            content: t(e).tip
          }, {
            default: r(() => [
              H("span", null, [
                w(m, {
                  size: "14",
                  style: { "vertical-align": "middle" }
                }, {
                  default: r(() => [
                    w(_)
                  ]),
                  _: 1
                }),
                H("span", null, Y(t(e).label), 1)
              ])
            ]),
            _: 1
          }, 8, ["content"])) : (l(), f("span", ne, Y(t(e).label), 1))
        ]),
        default: r(() => [
          R.value ? (l(), a(x, i({ key: 0 }, t(e), { onInput: F }, p(t(e))), le({ _: 2 }, [
            t(e).prepend ? {
              name: "prepend",
              fn: r(() => [
                I(n.$slots, "prepend")
              ]),
              key: "0"
            } : void 0,
            t(e).append ? {
              name: "append",
              fn: r(() => [
                I(n.$slots, "append")
              ]),
              key: "1"
            } : void 0
          ]), 1040)) : c("", !0),
          t(e).type === "secSech" ? (l(), a(D, i({
            key: 1,
            value: g.value
          }, t(e), {
            multiple: !!t(e).multiple,
            filterable: "",
            remote: "",
            "reserve-keyword": "",
            placeholder: "请输入关键字",
            "remote-show-suffix": "",
            "remote-method": t(e).remoteMethod,
            loading: t(e).loading
          }), {
            default: r(() => [
              (l(!0), f(b, null, h(t(e).options, (o) => (l(), a(C, {
                key: o.value,
                label: o.label,
                value: o.value
              }, null, 8, ["label", "value"]))), 128))
            ]),
            _: 1
          }, 16, ["value", "multiple", "remote-method", "loading"])) : c("", !0),
          t(e).type === "secTree" ? (l(), a(O, i({
            key: 2,
            value: g.value,
            ref_key: "treeRef",
            ref: S
          }, t(e), {
            data: t(e).tData,
            multiple: !!t(e).multiple,
            "render-after-expand": !1,
            "show-checkbox": "",
            filterable: "",
            "check-strictly": !t(e).noStrictly,
            "check-on-click-node": "",
            onChange: Q,
            onVisibleChange: t(e).visibleChange
          }, p(t(e))), null, 16, ["value", "data", "multiple", "check-strictly", "onVisibleChange"])) : c("", !0),
          t(e).type === "number" ? (l(), a(q, i({ key: 3 }, t(e), { onInput: F }, p(t(e))), null, 16)) : c("", !0),
          t(e).type === "psd" ? (l(), a(x, i({ key: 4 }, t(e), {
            type: "password",
            onInput: F,
            "show-password": ""
          }, p(t(e))), null, 16)) : c("", !0),
          t(e).type === "selectIcon" ? (l(), a(D, i({ key: 5 }, t(e), {
            value: n.selectValueIcon,
            clearable: "",
            filterable: !0,
            onChange: y,
            placeholder: "请选择一个图标"
          }), {
            prefix: r(() => [
              w(m, { size: 20 }, {
                default: r(() => [
                  (l(), a($(t(e).modelValue)))
                ]),
                _: 1
              })
            ]),
            default: r(() => [
              (l(!0), f(b, null, h(t(e).options, (o, d) => (l(), a(C, {
                key: d,
                label: o,
                value: o
              }, {
                default: r(() => [
                  w(m, { size: 20 }, {
                    default: r(() => [
                      (l(), a($(o)))
                    ]),
                    _: 2
                  }, 1024)
                ]),
                _: 2
              }, 1032, ["label", "value"]))), 128))
            ]),
            _: 1
          }, 16, ["value"])) : c("", !0),
          t(e).type === "select" ? (l(), a(D, i({ key: 6 }, t(e), {
            value: g.value,
            filterable: t(e).filterable,
            onChange: y
          }, p(t(e))), {
            default: r(() => [
              (l(!0), f(b, null, h(t(e).options, (o) => (l(), a(C, {
                label: o.label,
                value: o.value,
                key: o.value
              }, {
                default: r(() => [
                  I(n.$slots, "default", { item: o })
                ]),
                _: 2
              }, 1032, ["label", "value"]))), 128))
            ]),
            _: 3
          }, 16, ["value", "filterable"])) : c("", !0),
          t(e).type === "radio" ? (l(), a(B, i({ key: 7 }, t(e), {
            value: g.value,
            onChange: y
          }, p(t(e))), {
            default: r(() => [
              (l(!0), f(b, null, h(t(e).options, (o, d) => (l(), a(G, {
                label: d,
                border: !!t(e).border,
                key: d
              }, {
                default: r(() => [
                  N(Y(o), 1)
                ]),
                _: 2
              }, 1032, ["label", "border"]))), 128))
            ]),
            _: 1
          }, 16, ["value"])) : c("", !0),
          t(e).type === "radioBtn" ? (l(), a(B, i({ key: 8 }, t(e), {
            value: g.value,
            onChange: y
          }, p(t(e))), {
            default: r(() => [
              (l(!0), f(b, null, h(t(e).options, (o, d) => (l(), a(J, {
                label: d,
                key: d
              }, {
                default: r(() => [
                  N(Y(o), 1)
                ]),
                _: 2
              }, 1032, ["label"]))), 128))
            ]),
            _: 1
          }, 16, ["value"])) : c("", !0),
          t(e).type === "checkbox" ? (l(), a(U, i({ key: 9 }, t(e), {
            value: g.value,
            onChange: y
          }, p(t(e))), {
            default: r(() => [
              (l(!0), f(b, null, h(t(e).options, (o, d) => (l(), a(K, {
                label: o.value,
                key: o.value
              }, {
                default: r(() => [
                  N(Y(o.label), 1)
                ]),
                _: 2
              }, 1032, ["label"]))), 128))
            ]),
            _: 1
          }, 16, ["value"])) : c("", !0),
          T.value ? (l(), a(W, i({ key: 10 }, t(e), {
            value: L.value,
            "value-format": E.value,
            "disabled-date": t(e).disabledDateFn,
            onChange: y,
            onCalendarChange: t(e).calendarChange
          }, p(t(e))), null, 16, ["value", "value-format", "disabled-date", "onCalendarChange"])) : c("", !0)
        ]),
        _: 3
      }, 16);
    };
  }
});
export {
  ue as default
};
